#!/bin/bash

# This file is part of Marionnet, a virtual network laboratory
# Copyright (C) 2023  Jean-Vincent Loddo
# Copyright (C) 2023  Université Sorbonne Paris Nord (USPN)
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# ---
SRC_PROJECT_DIR="$(dirname $0)/.."
# ---
SOURCE=${1:-"$SRC_PROJECT_DIR/META"}
TARGET=${2:-"$SRC_PROJECT_DIR/version.ml"}
# ---
# Example of the content of META:
# ---
# name="marionnet"
# description="A virtual network laboratory"
# version="trunk"
# requires="threads str unix lablgtk3 lablglade ocamlbricks"
# ---
# Default:
version="trunk"
# ---
if test -f $SOURCE; then
  source $SOURCE
else
  echo 1>&2 "Warning: file $SOURCE not found => using the defaut value \"$version\""
fi
# ---
cat >$TARGET <<EOF
(* This file is automatically generated. Please don't edit it. *)
(* --- *)
let version = "${version:-"trunk"}";;
let build_time = "built in $(date +"%B %Y")";;
EOF

